// cpuspeed.cpp
//
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

extern "C" {
__declspec(dllexport) unsigned int GetCPUSpeed(void);
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved )
{
    return TRUE;
}

__declspec(dllexport) unsigned int GetCPUSpeed(void)
{
  DWORD DelayTime = 500;

  DWORD TimerHi, TimerLo;
  int PriorityClass, Priority;

  PriorityClass = GetPriorityClass(GetCurrentProcess());
  Priority = GetThreadPriority(GetCurrentThread());

  SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  __asm {
    ;rdtsc
    _emit 0Fh
    _emit 31h
    mov TimerLo, eax
    mov TimerHi, edx
  }
  Sleep(DelayTime);
  __asm {
    ;rdtsc
    _emit 0Fh
    _emit 31h
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  }

  SetThreadPriority(GetCurrentThread(), Priority);
  SetPriorityClass(GetCurrentProcess(), PriorityClass);

  return (TimerLo / (1000 * DelayTime));
}
